/*
  usock - A Tiny TCP/UDP Socket Library
  Configuration file

  T. Nakagawa
  2010-04-09
*/


#ifndef _CONFIG_H_
#define _CONFIG_H_


#define MTU 256		/* Maximum transfer unit */
#define TCB_SIZE 2	/* Maximum number of connections */
#define WIN_SIZE 3072	/* Window size of TCP */
#define TIMEOUT 50	/* Timeout of usock_* functions [100msec] (1-65535) */
#define TTL 255		/* Time to live of IP */
#define ARPTBL_SIZE 4	/* ARP table size (1-127) */
#define ARP_LIFETIME 60	/* Lifetime of entries in ARP table [sec] */

#define HTONS(x) ((uint16_t)(((uint16_t)(x) << 8) | ((uint16_t)(x) >> 8)))
#define HTONL(x) ((((x) & 0x000000ff) << 24) | (((x) & 0x0000ff00) << 8) | (((x) & 0x00ff0000) >> 8) | ((x) >> 24))
#define NTOHS(x) HTONS(x)
#define NTOHL(x) HTONL(x)

#define MACADDR0 0x00
#define MACADDR1 0x00
#define MACADDR2 0x00
#define MACADDR3 0x00
#define MACADDR4 0x00
#define MACADDR5 0x00

#define IPADDR0 192
#define IPADDR1 168
#define IPADDR2 0
#define IPADDR3 40
#define NMASK0 255
#define NMASK1 255
#define NMASK2 255
#define NMASK3 0
#define DRADDR0 192
#define DRADDR1 168
#define DRADDR2 0
#define DRADDR3 1


#endif
