/*
  tftpd - usock sample program

  T. Nakagawa
  2010-04-11
*/

#include <string.h>
#include "usock.h"

int main(void) {
  int8_t i;
  int8_t sd;

  for (; ; ) {
    if ((sd = usock_open(USOCK_UDP, 69, 0, (void *)0)) < 0) continue;

    if (Usock_size < 9 || memcmp(Usock_data, "\x00\x01sample\x00", 9) != 0) {
      usock_alloc(sd);
      memcpy(Usock_data, "\x00\x05\x00\x02Unsupported operation\x00", 26);
      Usock_size = 26;
      usock_send(sd);
      usock_recv(sd);	/* ACK */
      usock_close(sd);
      continue;
    }
    for (i = 0; i < 10; i++) {	/* retry */
      usock_alloc(sd);
      memcpy(Usock_data, "\x00\x03\x00\x01hello, world\n", 17);
      Usock_size = 17;
      usock_send(sd);

      if (usock_recv(sd)) continue;
      if (Usock_size == 4 && memcmp(Usock_data, "\x00\x04\x00\x01", 4) == 0) break;
    }

    usock_close(sd);
  }

  return 0;
}
