/*
  usock - A Tiny TCP/UDP Socket Library

  T. Nakagawa
  2010-04-06
*/


#ifndef _USOCK_H_
#define _USOCK_H_


#include <stdint.h>


#define USOCK_UDP 0
#define USOCK_TCP 1

#define USOCK_RDEOF(sd) (!((Usock_tcb[(sd)].stat & 0x02)))
#define USOCK_WREOF(sd) (!((Usock_tcb[(sd)].stat & 0x04)))
#define USOCK_LPORT(sd) (Usock_tcb[(sd)].lport)
#define USOCK_RPORT(sd) (Usock_tcb[(sd)].rport)
#define USOCK_RADDR(sd) (Usock_tcb[(sd)].raddr)


/*
  Transmision control block
*/
struct Usock_tcb {
  uint8_t stat;
  uint8_t mode;
  uint16_t lport;
  uint16_t rport;
  uint8_t raddr[4];
  uint32_t rcvnxt;
  uint32_t sndnxt;
  uint16_t mss;
};


int8_t usock_open(uint8_t mode, uint16_t lport, uint16_t rport, uint8_t *raddr);
void usock_close(int8_t sd);
void usock_alloc(int8_t sd);
int8_t usock_recv(int8_t sd);
uint16_t usock_send(int8_t sd);


extern uint8_t Usock_ipaddress[4];
extern uint8_t Usock_netmask[4];
extern uint8_t Usock_defaultrouter[4];
extern uint16_t Usock_timeout;
extern uint8_t *Usock_data;
extern uint16_t Usock_size;
extern uint16_t Usock_max;

extern struct Usock_tcb Usock_tcb[];


#endif
